#include "enter"

#ifndef (MAKECHAIN_INC)
  #declare MAKECHAIN_INC = 1 ;

  #include "metrics.inc"
  #ifndef (HighQuality)
    #declare HighQuality = on ;
  #end
  #include "machtext.inc"
  #include "gauges.inc"
  
  #if (!included)
    sky_sphere {
      pigment {
	gradient y
	color_map {
	  [ 0.0 rgb 1.0 ]
	  [ 1.0 rgb <0.0, 0.0, 1.0> ]
	}
      }
    }
  #end

  //------------------------------------------------------------------
  
  #macro ChromeTexture2()
    texture { 
      TChrome
      normal {
	bumps 1*mm
	scale 5*mm
      }
    }
    texture { 
      Scarring 
      scale 1*cm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture { 
      Chipping2
      scale 1*mm
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
    }
    texture {
      Rusting
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 1*mm
    }
    texture {
      Rusting
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 2*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 1*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 2*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 4*mm
    }
    texture {
      Rusting2
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 8*mm
    }
    texture {
      Dirt
      translate <rand (Seed)*m, rand (Seed)*m, rand (Seed)*m>
      scale 1*cm
    }
  #end
  
  //------------------------------------------------------------------
  
  #declare link_thick = 0.1 ;
  #declare link_width = 0.4 ;
  #declare half_torus = intersection {
    torus { link_width, link_thick }
    plane { x, 0 }
    bounded_by { 
      box { 
	-<link_width+link_thick, link_thick, link_width+link_thick>,
	<0, link_thick, link_width+link_thick>
      }
    }
    translate x*(link_width-link_thick)
  }
  #declare cyl_link = cylinder {
    <link_width-link_thick,0,0>,<1-(link_width-link_thick),0,0>, link_thick
  }

  #declare link = union {
    object { half_torus }
    object { half_torus scale <-1,1,1> translate x*1 }
    object { cyl_link translate z*link_width }
    object { cyl_link translate -z*link_width }
    rotate 88*x
    ChromeTexture2()
  }
  
  #declare link_length   = 5*cm ;
  #declare link_rotation = 85 ;
  #declare link_error    = 0.1 ;
  #declare chain_start   = <-60*cm, 1*m, 0> ;
  #declare chain_end     = <60*cm, 1*m, 0> ;
  #declare chain_scale   = 0.573/m ;
  #declare chain_type    = 1 ;
  #declare chain_debug   = off ;
  #declare Chain = union {
    #include "chain11.inc"
  }
  
  #declare chain_start   = <-47.5*cm, 1*m, 0> ;
  #declare chain_end     = <57.5*cm, 0, 0> ;
  #declare chain_scale   = 1.0/m ;  
  #declare Chain2 = union {
    #include "chain11.inc"
  }
  
  //------------------------------------------------------------------
 
  #if (!included)
    global_settings {
      assumed_gamma 1
    }
    camera {
      location -3*m*z+50*cm*y
      look_at  50*cm*y
      angle 40
    }
    light_source {
      <1000, 1000, -1000>*m
      color rgb 1
    }
    light_source {
      <-1000, 1000, -1000>*m
      color rgb 1/4
    }
    light_source {
      <0, 1000, 1000>*m
      color rgb 1/4
    }
    object { Chain2 }
  #end
#end

#include "leave"